/* Utils.c generated by valac 0.36.12, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright (c) 2018 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define UTILS_TYPE_DISPLAY_TYPE (utils_display_type_get_type ())

typedef enum  {
	UTILS_DISPLAY_TYPE_INTERNAL,
	UTILS_DISPLAY_TYPE_EXTERNAL
} UtilsDisplayType;



GType utils_display_type_get_type (void) G_GNUC_CONST;
gchar* utils_display_type_to_string (UtilsDisplayType self);
gchar* utils_display_type_icon_suffix (UtilsDisplayType self);
gint utils_dpi (gdouble inches, gint width, gint height);
gint utils_greatest_common_divisor (gint a, gint b);


gchar* utils_display_type_to_string (UtilsDisplayType self) {
	gchar* result = NULL;
	switch (self) {
		case UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Laptop"));
			result = _tmp0_;
			return result;
		}
		case UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Desktop"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


gchar* utils_display_type_icon_suffix (UtilsDisplayType self) {
	gchar* result = NULL;
	switch (self) {
		case UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("-notebook");
			result = _tmp0_;
			return result;
		}
		case UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}


GType utils_display_type_get_type (void) {
	static volatile gsize utils_display_type_type_id__volatile = 0;
	if (g_once_init_enter (&utils_display_type_type_id__volatile)) {
		static const GEnumValue values[] = {{UTILS_DISPLAY_TYPE_INTERNAL, "UTILS_DISPLAY_TYPE_INTERNAL", "internal"}, {UTILS_DISPLAY_TYPE_EXTERNAL, "UTILS_DISPLAY_TYPE_EXTERNAL", "external"}, {0, NULL, NULL}};
		GType utils_display_type_type_id;
		utils_display_type_type_id = g_enum_register_static ("UtilsDisplayType", values);
		g_once_init_leave (&utils_display_type_type_id__volatile, utils_display_type_type_id);
	}
	return utils_display_type_type_id__volatile;
}


gint utils_dpi (gdouble inches, gint width, gint height) {
	gint result = 0;
	gdouble unrounded_dpi = 0.0;
	gint _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gint rounded_dpi = 0;
	_tmp0_ = width;
	_tmp1_ = pow ((gdouble) _tmp0_, (gdouble) 2);
	_tmp2_ = height;
	_tmp3_ = pow ((gdouble) _tmp2_, (gdouble) 2);
	_tmp4_ = sqrt (_tmp1_ + _tmp3_);
	_tmp5_ = inches;
	unrounded_dpi = _tmp4_ / _tmp5_;
	rounded_dpi = (gint) unrounded_dpi;
	result = rounded_dpi;
	return result;
}


gint utils_greatest_common_divisor (gint a, gint b) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp2_;
	gint _tmp4_;
	gint _tmp5_;
	_tmp0_ = a;
	if (_tmp0_ == 0) {
		gint _tmp1_;
		_tmp1_ = b;
		result = _tmp1_;
		return result;
	}
	_tmp2_ = b;
	if (_tmp2_ == 0) {
		gint _tmp3_;
		_tmp3_ = a;
		result = _tmp3_;
		return result;
	}
	_tmp4_ = a;
	_tmp5_ = b;
	if (_tmp4_ > _tmp5_) {
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		_tmp6_ = a;
		_tmp7_ = b;
		_tmp8_ = b;
		_tmp9_ = utils_greatest_common_divisor (_tmp6_ % _tmp7_, _tmp8_);
		result = _tmp9_;
		return result;
	} else {
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		_tmp10_ = a;
		_tmp11_ = b;
		_tmp12_ = a;
		_tmp13_ = utils_greatest_common_divisor (_tmp10_, _tmp11_ % _tmp12_);
		result = _tmp13_;
		return result;
	}
}



